unit SnapForm;

interface

uses Windows, Messages, NForm;

type
  TSnapForm = class(TForm)
    MoveX: Integer;
    MoveY: Integer;
    procedure WMMoving(var Message: TMessage); message WM_MOVING;
  end;

implementation

procedure TSnapForm.WMMoving(var Message: TMessage);
  procedure Snap(var Rect: TRect; const BoundRect: TRect; dx, dy: Integer;
      snaplen: Integer);
  begin
    if Abs(dx) < snaplen then
    begin
      Dec(MoveX, dx);
      if Abs(MoveX) > snaplen then
      begin
        Inc(Rect.Left, MoveX);
        Inc(Rect.Right, MoveX);
        MoveX := 0;
      end
      else begin
        Inc(Rect.Left, dx);
        Inc(Rect.Right, dx);
      end;
    end;
    if Abs(dy) < snaplen then
    begin
      Dec(MoveY, dy);
      if Abs(MoveY) > snaplen then
      begin
        Inc(Rect.Top, MoveY);
        Inc(Rect.Bottom, MoveY);
        MoveY := 0;
      end
      else begin
        Inc(Rect.Top, dy);
        Inc(Rect.Bottom, dy);
      end;
    end;
  end;
const
  snaplen = 10;
var
  rc: PRect;
  drc: TRect;
begin
  rc := PRect(Message.LParam);
  GetWindowRect(GetDesktopWindow, drc);
  Snap(rc^, drc, drc.Left-rc.Left, drc.Top-rc.Top, snaplen);
  Snap(rc^, drc, drc.Right-rc.Right, drc.Bottom-rc.Bottom, snaplen);
  Message.Result := LRESULT(True);
end;

end.
